xine-lib: xine-lib-1.2.13/src/post/deinterlace/plugins/greedy.c File Reference

xine-lib 1.2.13-20230125hg15249

Functions | Variables
greedy.c File Reference
`#include <stdio.h>`
`#include <stdint.h>`
`#include <xine/attributes.h>`
`#include <xine/xineutils.h>`
`#include "xine_mmx.h"`
`#include "deinterlace.h"`
`#include "speedtools.h"`
`#include "speedy.h"`
`#include "plugins.h"`

## Functions
static void | copy_scanline (uint8_t *output, deinterlace_scanline_data_t *data, int width)
static void | deinterlace_greedy_packed422_scanline_mmxext (uint8_t *output, deinterlace_scanline_data_t *data, int width)
const deinterlace_method_t * | greedy_get_method (void)

## Variables
static const deinterlace_method_t | greedymethod

## Function Documentation

## ◆ copy_scanline()

static void copy_scanline | ( | uint8_t * | output,
|  | deinterlace_scanline_data_t * | data,
|  | int | width )
| static

Copyright (c) 2000 Tom Barry All rights reserved. mmx.h port copyright (c) 2002 Billy Biggs vekto.nosp@m.r@du.nosp@m.mbter.nosp@m.m.ne.nosp@m.t.

This code is ported from DScaler: http://deinterlace.sf.net/

This library is free software; you can redistribute it and/or modify it under the terms of the GNU Lesser General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License along with this library; if not, write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

References blit_packed422_scanline, deinterlace_scanline_data_s::m1, and width.

## ◆ deinterlace_greedy_packed422_scanline_mmxext()

static void deinterlace_greedy_packed422_scanline_mmxext | ( | uint8_t * | output,
|  | deinterlace_scanline_data_t * | data,
|  | int | width )
| static

References deinterlace_scanline_data_s::b1, emms, deinterlace_scanline_data_s::m0, deinterlace_scanline_data_s::m2, movntq_r2m, movq_m2r, movq_r2r, paddusb_m2r, paddusb_r2r, pand_r2r, pavgb_r2r, pcmpeqb_r2r, por_r2r, psubusb_m2r, psubusb_r2r, sfence, deinterlace_scanline_data_s::t1, mmx_t::ub, and width.

## ◆ greedy_get_method()

const deinterlace_method_t * greedy_get_method | ( | void |  | ) |

Copyright (C) 2002, 2004 Billy Biggs vekto.nosp@m.r@du.nosp@m.mbter.nosp@m.m.ne.nosp@m.t.

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110, USA. tvtime was going to have a plugin system, but there was never any interest in it outside of tvtime, so instead we include all deinterlacer methods right in the tvtime executable.

References greedymethod.

Referenced by deinterlace_init_plugin().

## Variable Documentation

## ◆ greedymethod

const deinterlace_method_t greedymethod
| static

Initial value:
=
{
"Greedy - Low motion (DScaler)",
"Greedy",
3,
MM_ACCEL_X86_MMXEXT,
0,
1,
copy_scanline,
deinterlace_greedy_packed422_scanline_mmxext,
0,
1,
"Uses heuristics to detect motion in the input frames and reconstruct "
"image detail where possible. Use this for high quality output even "
"on monitors set to an arbitrary refresh rate.\n"
"\n"
"Simple detection uses linear interpolation where motion is detected, "
"using a two-field buffer. This is the Greedy: Low Motion deinterlacer "
"from DScaler."
}
copy_scanline
static void copy_scanline(uint8_t *output, deinterlace_scanline_data_t *data, int width)
Definition greedy.c:55
deinterlace_greedy_packed422_scanline_mmxext
static void deinterlace_greedy_packed422_scanline_mmxext(uint8_t *output, deinterlace_scanline_data_t *data, int width)
Definition greedy.c:62
MM_ACCEL_X86_MMXEXT
#define MM_ACCEL_X86_MMXEXT
Definition xineutils.h:167

The greedy deinterlacer introduces a one-field delay on the input. From the diagrams in deinterlace.h, the field being deinterlaced is always t-1. For this reason, our copy_scanline method is used for deinterlace_method_t's interpolate_scanline function, and the real work is done in deinterlace_method_t's copy_scanline function.

Referenced by greedy_get_method().